apiVersion: v1
kind: ConfigMap
metadata:
  name: maildrop-redis-kube-proxy
  namespace: ci
data:
  haproxy.cfg: |
    global
        log stdout format raw local0
        maxconn 10240
        spread-checks 5
        stats socket /tmp/hactl level admin
        stats timeout 30s

    defaults
        log global
        mode tcp
        maxconn 10240
        timeout client 1s
        timeout connect 2s
        timeout queue 10s
        timeout server 5s

    frontend stats
        bind :9113
        option http-use-htx
        http-request use-service prometheus-exporter if { path /metrics }
        stats enable
        stats uri /stats
        stats refresh 10s

    frontend redis
        bind *:6379
        default_backend redis-backend

    resolvers dns
        parse-resolv-conf
        resolve_retries 3
        timeout resolve 1s
        timeout retry 1s
        hold other 30s
        hold refused 30s
        hold nx 30s
        hold timeout 30s
        hold valid 10s
        hold obsolete 30s

    backend redis-backend
        option tcp-check
        tcp-check send PING\r\n
        tcp-check expect string +PONG
        tcp-check send info\ replication\r\n
        tcp-check expect string role:master
        tcp-check send QUIT\r\n
        tcp-check expect string +OK
        balance leastconn
        server redis-0 maildrop-redis-kube-0.maildrop-redis-kube.ci.svc.cluster.local:6379 check resolvers dns check inter 5000
        server redis-1 maildrop-redis-kube-1.maildrop-redis-kube.ci.svc.cluster.local:6379 check resolvers dns check inter 5000
        server redis-2 maildrop-redis-kube-2.maildrop-redis-kube.ci.svc.cluster.local:6379 check resolvers dns check inter 5000
